commit bfd2759002fd2b5b376a1544e8fc59f313dc4e9c
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Mon Dec 22 10:10:01 2025 +0000

    Disable -bI:sieve for sieve-less builds.  Bug 3184

diff --git a/src/src/drtables.c b/src/src/drtables.c
index 1b9dc0c98..29ae84bd6 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -348,8 +348,9 @@ if ((mi = misc_mod_findonly(name))) return mi;
 #ifdef LOOKUP_MODULE_DIR
 return misc_mod_load(name, errstr);
 #else
-*errstr = string_sprintf("module %q not built-in, and"
-	" no setting for LOOKUP_MODULE_DIR", name);
+if (errstr)
+  *errstr = string_sprintf("module %q not built-in, and"
+	  " no setting for LOOKUP_MODULE_DIR", name);
 return NULL;
 #endif	/*LOOKUP_MODULE_DIR*/
 }
diff --git a/src/src/exim.c b/src/src/exim.c
index 055882ad0..8c5089f7b 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -85,7 +85,10 @@ function_store_nullfree(void * block, void * tag)
 *************************************************/
 
 enum commandline_info { CMDINFO_NONE=0,
-  CMDINFO_HELP, CMDINFO_SIEVE, CMDINFO_MODULES,
+  CMDINFO_HELP, CMDINFO_MODULES,
+#ifndef DISABLE_SIEVE_FILTER
+  CMDINFO_SIEVE,
+#endif
 #ifdef SUPPORT_DSCP
   CMDINFO_DSCP
 #endif
@@ -1393,27 +1396,30 @@ switch(request)
 "  exim -bI:dscp    list of known dscp value keywords\n"
 #endif
 "  exim -bI:modules list of loadable modules\n"
+#ifndef DISABLE_SIEVE_FILTER
 "  exim -bI:sieve   list of supported sieve extensions\n"
+#endif
 );
     return;
   case CMDINFO_MODULES:
     mod_names(stream);
     return;
+#ifndef DISABLE_SIEVE_FILTER
   case CMDINFO_SIEVE:
     {
-    const misc_module_info * mi;
+    misc_module_info * mi = misc_mod_find(US"sieve_filter", NULL);
     typedef void (*fn_t)(FILE *);
-    if ((mi = misc_mod_find(US"sieve_filter", NULL)))
+    if (mi)
       (((fn_t *) mi->functions)[SIEVE_EXTENSIONS]) (stream);
     else
       fprintf(stream, "Sieve filtering not available\n");
     }
     return;
+#endif
 #ifdef SUPPORT_DSCP
   case CMDINFO_DSCP:
     {
-    uschar * dummy_errstr;
-    misc_module_info * mi = misc_mod_find(US"dscp", &dummy_errstr);
+    misc_module_info * mi = misc_mod_find(US"dscp", NULL);
     typedef void (*fn_t)(FILE *);
     if (mi) ((fn_t *) mi->functions)[DSCP_KEYWORDS] (stream);
     }
@@ -2438,10 +2444,12 @@ on the second character (the one after '-'), to save some effort. */
 	    const uschar * p = argrest+1;
 	    info_flag = CMDINFO_HELP;
 	    if (Ustrlen(p))
-	      if (strcmpic(p, CUS"sieve") == 0)
-		{ info_flag = CMDINFO_SIEVE; info_stdout = TRUE; }
-	      else if (strcmpic(p, CUS"modules") == 0)
+	      if (strcmpic(p, CUS"modules") == 0)
 		{ info_flag = CMDINFO_MODULES; info_stdout = TRUE; }
+#ifndef DISABLE_SIEVE_FILTER
+	      else if (strcmpic(p, CUS"sieve") == 0)
+		{ info_flag = CMDINFO_SIEVE; info_stdout = TRUE; }
+#endif
 #ifdef SUPPORT_DSCP
 	      else if (strcmpic(p, CUS"dscp") == 0)
 		{ info_flag = CMDINFO_DSCP; info_stdout = TRUE; }
diff --git a/src/src/expand.c b/src/src/expand.c
index b0500037d..85d27b534 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -2802,7 +2802,8 @@ switch(cond_type = identify_operator(&s, &opname))
     case ECOND_RADIUS:
 #ifdef RADIUS_CONFIG_FILE
       {
-      const misc_module_info * mi = misc_mod_find(US"radius", NULL);
+      uschar * dummy_errstr;
+      const misc_module_info * mi = misc_mod_find(US"radius", &dummy_errstr);
       typedef int (*fn_t)(const uschar *, uschar **);
       if (!mi)
 	goto COND_FAILED_NOT_COMPILED;
diff --git a/src/src/lookups/spf.c b/src/src/lookups/spf.c
index a8404d9bf..e41e1dcb0 100644
--- a/src/src/lookups/spf.c
+++ b/src/src/lookups/spf.c
@@ -84,8 +84,7 @@ return FAIL;
 gstring *
 spf_version_report(gstring * g)
 {
-uschar * dummy_errmsg;
-misc_module_info * mi = misc_mod_find(US"spf", &dummy_errmsg);
+misc_module_info * mi = misc_mod_find(US"spf", NULL);
 return mi && mi->lib_vers_report ? mi->lib_vers_report(g) : g;
 }
 
diff --git a/src/src/smtp_in.c b/src/src/smtp_in.c
index da919048c..643d88ca2 100644
--- a/src/src/smtp_in.c
+++ b/src/src/smtp_in.c
@@ -2669,11 +2669,10 @@ Failure will not allow any SMTP function other than QUIT. */
 f.quit_cmd_only = FALSE;
 if (hosts_proxy)
   {
-  uschar * dummy_errmsg;
   misc_module_info * mi;
   typedef BOOL (*fn_t) (void);
 
-  if (!(mi = misc_mod_find(US"proxy", &dummy_errmsg)))
+  if (!(mi = misc_mod_find(US"proxy", NULL)))
     {
     smtp_closedown(US"Temporary local problem - please try later");
     return FALSE;
@@ -4443,11 +4442,10 @@ while (done <= 0)
 #ifdef EXPERIMENTAL_XCLIENT
 	if (proxy_session || verify_check_host(&hosts_xclient) != FAIL)
 	  {
-	  uschar * dummy_errmsg;
 	  typedef gstring * (*fn_t) (gstring *);
 
 	  if (  !xclient_mi
-	     && !(xclient_mi = misc_mod_find(US"xclient", &dummy_errmsg)))
+	     && !(xclient_mi = misc_mod_find(US"xclient", NULL)))
 	    {
 	    smtp_closedown(US"Temporary local problem - please try later");
 	    return FALSE;
diff --git a/src/src/smtp_out.c b/src/src/smtp_out.c
index a5557d09e..2712ee0ce 100644
--- a/src/src/smtp_out.c
+++ b/src/src/smtp_out.c
@@ -296,8 +296,7 @@ bomb out, just log it and continue in default traffic class. */
   GET_OPTION("dscp");
   if (ob->dscp)
     {
-    uschar * dummy_errstr;
-    misc_module_info * mi = misc_mod_find(US"dscp", &dummy_errstr);
+    misc_module_info * mi = misc_mod_find(US"dscp", NULL);
     typedef void (*fn_t)(int, const uschar *, int);
     if (mi)
       ((fn_t *) mi->functions)[DSCP_TRANSPORT] (sock, ob->dscp, sc->host_af);
@@ -521,8 +520,7 @@ if (ob->socks_proxy)
     }
   if (*ob->socks_proxy)
     {
-    uschar * dummy_errmsg;
-    misc_module_info * mi = misc_mod_find(US"socks", &dummy_errmsg);
+    misc_module_info * mi = misc_mod_find(US"socks", NULL);
     typedef int (*fn_t) (const smtp_connect_args *, const blob *);
     return mi ? ((fn_t *) mi->functions)[SOCKS_CONNECT] (sc, early_data) : -1;
     }

